package lawOfDemeter;

import org.aspectj.lang.reflect.*;
import org.aspectj.lang.*;
import testcase.*;            // general tests

/**
 * @author Paul Freeman
 */

privileged aspect Tests {

  public static void main(String[] args){
    ATest();
    OriginalFooTest();
  }

  pointcut specificRun():
    call(* *Test*(..)) && !Any.scope();

  void around(): Tests.specificRun(){
    System.out.println("*** running " +
      ((MethodSignature)thisJoinPointStaticPart.getSignature()).getName() +
      " ***");
    proceed();
    System.out.println("");
  }

  public static void ATest(){
    Main m = new Main();
    m.DirectPartsTests();
    m.LocallyConstructedTests();
    m.ReturnTypeTests();
    m.ArgumentTests(new testcase.A());
  }

  public static void OriginalFooTest(){
    testcase.Foo.main(new String[0]);
  }
}